<script>
	import anime from 'animejs/lib/anime.es.js';
	export default {
		name: 'App',

		data () {
			return {
				time: '',
				date: '',
				week: ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'],
				position: {
					x: 1,
					y: 1
				},
				backdrop: false
			}
		},

		methods: {
			updateTime () {
				let cd = new Date()
				this.time = this.zeroPadding(cd.getHours(), 2) + ':' + this.zeroPadding(cd.getMinutes(), 2) + ':' + this.zeroPadding(cd.getSeconds(), 2)
				this.date = this.zeroPadding(cd.getDate(), 2) + '-' + this.zeroPadding(cd.getMonth() + 1, 2) + '-' + this.zeroPadding(cd.getFullYear(), 4) + ' ' + this.week[cd.getDay()]
			},

			zeroPadding (num, digit) {
				var zero = ''
				for (var i = 0; i < digit; i++) {
					zero += '0'
				}
				return (zero + num).slice(-digit)
			},

			clickHandler () {
				this.openFullscreen()
				anime({
					targets: '.tile',
					scale: [
						{value: .97, easing: 'easeOutElastic', duration: 100},
						{value: 1, easing: 'easeInOutQuad', duration: 100}
					],
					delay: anime.stagger(20, {grid: [this.position.x+1, this.position.y+1], from: 'center'})
				});

				if (this.position.x === 0 && this.position.y === 0) {
					this.toggle('cinema')
				}
				if (this.position.x === 1 && this.position.y === 1) {
					this.toggle('Toggle')
				}
				if (this.position.x === 1 && this.position.y === 0) {
					this.toggle('normal')
				}
				if (this.position.x === 0 && this.position.y === 1) {
					this.toggle('red')
				}
				if (this.position.x === 2 && this.position.y === 1) {
					this.backdrop = !this.backdrop;
				}
			},

			openFullscreen () {
				const elem = document.documentElement
				if (elem.requestFullscreen) {
					elem.requestFullscreen()
				} else if (elem.mozRequestFullScreen) { /* Firefox */
					elem.mozRequestFullScreen()
				} else if (elem.webkitRequestFullscreen) { /* Chrome, Safari & Opera */
					elem.webkitRequestFullscreen()
				} else if (elem.msRequestFullscreen) { /* IE/Edge */
					elem.msRequestFullscreen()
				}
			},

			toggle (event) {
				const xhttp = new XMLHttpRequest()

				xhttp.open('GET', `https://maker.ifttt.com/trigger/${event}/with/key/c-lDeqRXzWcEdX_x0Ig20G`, true)
				xhttp.send()
			},

			getDollar () {
				const xhttp = new XMLHttpRequest()

				xhttp.open('GET', `http://www.melhorcambio.com/dolar-hoje`, true)
				xhttp.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						// Typical action to be performed when the document is ready:
						console.log(xhttp.responseText)
					}
				}
				xhttp.send()
			}
		},

		created () {
			this.getDollar();
			this.updateTime()
			setInterval(this.updateTime, 1000)

			let direction = '',
			  oldy = 0,
			  oldx = 0,
			  mousemovemethod = (e) => {

				  if (e.pageX < oldx) {
					  // direction = "left"
					  if (this.position.x > 0) {
						  this.position.x--
					  }
				  } else if (e.pageX > oldx) {
					  // direction = 'right'
					  if (this.position.x < 3) {
						  this.position.x++
					  }
				  } else if (e.pageY < oldy) {
					  // direction = 'up'
					  if (this.position.y > 0) {
						  this.position.y--
					  }
				  } else if (e.pageY > oldy) {
					  // direction = 'down'
					  if (this.position.y < 2) {
						  this.position.y++
					  }
				  }

				  oldx = e.pageX
				  oldy = e.pageY
			  }

			document.addEventListener('mousemove', mousemovemethod)
		}
	}
</script>

<template>
	<div id="app" @click="clickHandler">
		<div class="overlay" v-if="backdrop"></div>
		<div class="row">
			<div
				class="tile tile--blue tile--cinema"
				:class="{'tile--hover': position.x === 0 && position.y === 0 }"
			></div>
			<div
				class="tile tile--yellow tile--light"
				:class="{'tile--hover': position.x === 1 && position.y === 0 }"
			></div>
			<div
				class="tile tile--purple"
				:class="{'tile--hover': position.x === 2 && position.y === 0 }"
			></div>
			<div
				class="tile tile--green"
				:class="{'tile--hover': position.x === 3 && position.y === 0 }"
			></div>
		</div>
		<div class="row">
			<div
				class="tile tile--red tile--roses"
				:class="{'tile--hover': position.x === 0 && position.y === 1 }"
			></div>
			<div
				class="tile" :class=
				"{'tile--hover': position.x === 1 && position.y === 1 }">

				<div id="clock">
					<p class="date">{{ date }}</p>
					<p class="time">{{ time }}</p>
				</div>
			</div>
			<div
				class="tile tile--dark-blue"
				:class="{'tile--hover': position.x === 2 && position.y === 1 }"
			></div>
			<div
				class="tile tile--yellow"
				:class="{'tile--hover': position.x === 3 && position.y === 1 }"
			></div>
		</div>
		<div class="row">
			<div
				class="tile tile--purple"
				:class="{'tile--hover': position.x === 0 && position.y === 2 }"
			></div>
			<div
				class="tile tile--green"
				:class="{'tile--hover': position.x === 1 && position.y === 2 }"
			></div>
			<div
				class="tile tile--red"
				:class="{'tile--hover': position.x === 2 && position.y === 2 }"
			></div>
			<div
				class="tile tile--blue"
				:class="{'tile--hover': position.x === 3 && position.y === 2 }"
			></div>
		</div>
	</div>
</template>

<style lang="scss">
	@import './assets/sass/main.scss';
</style>
